"""
Django settings for somoffice project.

Generated by 'django-admin startproject' using Django 2.1.7.

For more information on this file, see
https://docs.djangoproject.com/en/2.1/topics/settings/

For the full list of settings and their values, see
https://docs.djangoproject.com/en/2.1/ref/settings/
"""

import os
from django.utils.translation import gettext_lazy as _
from datetime import timedelta

# Build paths inside the project like this: os.path.join(BASE_DIR, ...)
BASE_DIR = os.path.dirname(os.path.dirname(os.path.abspath(__file__)))


# Quick-start development settings - unsuitable for production
# See https://docs.djangoproject.com/en/2.1/howto/deployment/checklist/

# SECURITY WARNING: keep the secret key used in production secret!
SECRET_KEY = os.environ.get("APPLICATION_SECRET_KEY")

# SECURITY WARNING: don't run with debug turned on in production!
DEBUG = os.environ.get("DJANGO_DEBUG_MODE", "no") == "yes"

ALLOWED_HOSTS = os.environ.get("ALLOWED_HOSTS", "").split(",")


# Application definition

INSTALLED_APPS = [
    "django.contrib.admin",
    "django.contrib.auth",
    "django.contrib.contenttypes",
    "django.contrib.sessions",
    "django.contrib.messages",
    "django.contrib.staticfiles",
    "rest_framework",
    "django_rest_passwordreset",
    "somoffice",
    "somconnexio",
]

BUGSNAG = {
    "api_key": os.getenv("BUGSNAG_SOMCONNEXIO_SOMOFFICE_BACKEND_API_KEY"),
    "release_stage": os.getenv("BUGSNAG_SOMCONNEXIO_SOMOFFICE_STAGE"),
}

MIDDLEWARE = [
    "django.middleware.security.SecurityMiddleware",
    "django.contrib.sessions.middleware.SessionMiddleware",
    "django.middleware.common.CommonMiddleware",
    "django.middleware.csrf.CsrfViewMiddleware",
    "django.contrib.auth.middleware.AuthenticationMiddleware",
    "django.contrib.messages.middleware.MessageMiddleware",
    "django.middleware.clickjacking.XFrameOptionsMiddleware",
    "bugsnag.django.middleware.BugsnagMiddleware",
    "somoffice.core.http.locale_middleware",
]

ROOT_URLCONF = "somoffice.urls"

TEMPLATES = [
    {
        "BACKEND": "django.template.backends.django.DjangoTemplates",
        "DIRS": [],
        "APP_DIRS": True,
        "OPTIONS": {
            "context_processors": [
                "django.template.context_processors.debug",
                "django.template.context_processors.request",
                "django.contrib.auth.context_processors.auth",
                "django.contrib.messages.context_processors.messages",
            ],
        },
    },
]

WSGI_APPLICATION = "somoffice.wsgi.application"


# Database
# https://docs.djangoproject.com/en/2.1/ref/settings/#databases

DATABASES = {
    "default": {
        "ENGINE": "django.db.backends.postgresql",
        "NAME": os.environ.get("DATABASE_NAME"),
        "USER": os.environ.get("DATABASE_USER"),
        "PASSWORD": os.environ.get("DATABASE_PASSWORD"),
        "HOST": os.environ.get("DATABASE_HOST"),
    }
}

AUTH_USER_MODEL = "somoffice.User"

# Password validation
# https://docs.djangoproject.com/en/2.1/ref/settings/#auth-password-validators

AUTH_PASSWORD_VALIDATORS = [
    {
        "NAME": "django.contrib.auth.password_validation.UserAttributeSimilarityValidator",
    },
    {"NAME": "django.contrib.auth.password_validation.MinimumLengthValidator",},
    {"NAME": "django.contrib.auth.password_validation.CommonPasswordValidator",},
    {"NAME": "django.contrib.auth.password_validation.NumericPasswordValidator",},
]

AUTHENTICATION_BACKENDS = [
    "somconnexio.domain.keycloak.KeycloakRemoteUserBackend",
]

# Internationalization
# https://docs.djangoproject.com/en/2.1/topics/i18n/

LANGUAGES = [
    ("es", _("Spanish")),
    ("ca", _("Catalan")),
]

LANGUAGE_CODE = "en-us"

TIME_ZONE = "UTC"

USE_I18N = True

USE_L10N = True

USE_TZ = True


# Change email verification config
EMAIL_CONFIRMATION_PERIOD = timedelta(days=14)

SESSION_COOKIE_AGE = timedelta(minutes=20).seconds
SESSION_SAVE_EVERY_REQUEST = True

REST_FRAMEWORK = {
    'EXCEPTION_HANDLER': 'somoffice.core.http.rest_framework_exception_handler',
}

# Static files (CSS, JavaScript, Images)
# https://docs.djangoproject.com/en/2.1/howto/static-files/

STATIC_URL = "/static/"

DJANGO_REST_LOOKUP_FIELD = "username"


if os.environ.get("EMAIL_USE_DUMMY_BACKEND") == "yes":
    EMAIL_BACKEND = "django.core.mail.backends.dummy.EmailBackend"
    EMAIL_FROM = os.environ.get("EMAIL_FROM")
else:
    EMAIL_BACKEND = "django.core.mail.backends.smtp.EmailBackend"
    EMAIL_HOST = os.environ.get("EMAIL_HOST")
    EMAIL_PORT = os.environ.get("EMAIL_PORT")
    EMAIL_HOST_USER = os.environ.get("EMAIL_HOST_USER")
    EMAIL_HOST_PASSWORD = os.environ.get("EMAIL_HOST_PASSWORD")
    EMAIL_USE_TLS = os.environ.get("EMAIL_USE_TLS") == "yes"
    EMAIL_FROM = os.environ.get("EMAIL_FROM")

# Application specific config
DEFAULT_DOMAIN = os.environ.get("DEFAULT_DOMAIN")
FRONTEND_BASE_URL = os.environ.get("FRONTEND_BASE_URL")

SOMOFFICE_RESOURCE_PROVIDERS = {
    "invoices": "somconnexio.providers.invoices.InvoicesProvider",
    "subscriptions": "somconnexio.providers.subscriptions.SubscriptionsProvider",
    "services_form": "somconnexio.providers.services_form.ServicesFormProvider",
    "users": "somconnexio.providers.users.UsersProvider",
    "products": "somconnexio.providers.products.ProductsProvider",
    "product_catalog": "somconnexio.providers.product_catalog.ProductCatalogProvider",
    "tickets": "somconnexio.providers.tickets.TicketsProvider",
    "available_providers": "somconnexio.providers.available_providers.AvailableProviders",
    "discovery_channels": "somconnexio.providers.discovery_channels.DiscoveryChannelsProvider",
    "profile": "somconnexio.providers.profile.ProfileProvider",
}


KEYCLOAK_SERVER_URL = os.environ.get("KEYCLOAK_SERVER_URL")
KEYCLOAK_CLIENT_ID = os.environ.get("KEYCLOAK_CLIENT_ID")
KEYCLOAK_CLIENT_SECRET = os.environ.get("KEYCLOAK_CLIENT_SECRET")
KEYCLOAK_REALM = os.environ.get("KEYCLOAK_REALM")
KEYCLOAK_ADMIN_USER = os.environ.get("KEYCLOAK_ADMIN_USER")
KEYCLOAK_ADMIN_PASSWORD = os.environ.get("KEYCLOAK_ADMIN_PASSWORD")

OPENCELL_BASEURL = os.environ.get("OPENCELL_BASEURL")
OPENCELL_USER = os.environ.get("OPENCELL_USER")
OPENCELL_PASSWORD = os.environ.get("OPENCELL_PASSWORD")

BASICAUTH_USERS = {"somoffice.admin": os.environ.get("SOMOFFICE_ADMIN_PASSWORD")}

OTRS_USER = os.environ.get("OTRS_USER")
OTRS_PASSWORD = os.environ.get("OTRS_PASSWORD")
OTRS_BASEURL = os.environ.get("OTRS_BASEURL")

SOMOFFICE_TICKET_FALLBACK_PATH = os.environ.get("SOMOFFICE_TICKET_FALLBACK_PATH")

# fmt: off
if not DEBUG:
    LOGGING = {
        'version': 1,
        'disable_existing_loggers': False,
        'handlers': {
            'console': {
                'class': 'logging.StreamHandler',
            },
        },
        'loggers': {
            'django': {
                'handlers': ['console'],
                'level': 'INFO',
                'propagate': False,
            },
            'django.server': {
                'handlers': ['console'],
                'level': 'INFO',
                'propagate': False,
            },
            'django.request': {
                'handlers': ['console'],
                'level': 'INFO',
                'propagate': False,
            },
            'django.db.backends': {
                'handlers': ['console'],
                'level': 'INFO',
                'propagate': False,
            },
            'django.security.csrf': {
                'handlers': ['console'],
                'level': 'INFO',
                'propagate': False,
            },
            'django.template': {
                'handlers': ['console'],
                'level': 'INFO',
                'propagate': False,
            },
            'bugsnag': {
                'level': 'ERROR',
                'class': 'bugsnag.handlers.BugsnagHandler',
            },
        },
    }

# fmt: on
